/// <reference path="../../adonis-typings/index.d.ts" />
/// <reference types="node" />
import { Macroable } from 'macroable';
import { DeepReadonly } from 'ts-essentials';
import { ServerResponse, IncomingMessage } from 'http';
import { CookieOptions } from '@poppinss/cookie';
import { ResponseContract, CastableHeader, LazyBody, ResponseContentType, ResponseStream, ResponseConfigContract } from '@ioc:Adonis/Core/Response';
export declare class Response extends Macroable implements ResponseContract {
    request: IncomingMessage;
    response: ServerResponse;
    private _config;
    lazyBody: LazyBody | null;
    protected static _macros: {};
    protected static _getters: {};
    private _headers;
    private _explicitStatus;
    constructor(request: IncomingMessage, response: ServerResponse, _config: DeepReadonly<ResponseConfigContract>);
    readonly hasLazyBody: boolean;
    readonly finished: boolean;
    readonly headersSent: boolean;
    readonly isPending: boolean;
    private _castHeaderValue;
    private _writeBody;
    private _streamBody;
    private _download;
    private _end;
    flushHeaders(statusCode?: number): this;
    getHeader(key: string): any;
    header(key: string, value: CastableHeader): this;
    append(key: string, value: CastableHeader): this;
    safeHeader(key: string, value: CastableHeader): this;
    removeHeader(key: string): this;
    status(code: number): this;
    safeStatus(code: number): this;
    type(type: string, charset?: string): this;
    vary(field: string): this;
    setEtag(body: any, weak?: boolean): this;
    fresh(): boolean;
    buildResponseBody(body: any): {
        body: any;
        type: ResponseContentType;
        originalType?: string;
    };
    send(body: any, generateEtag?: boolean): void;
    json(body: any, generateEtag?: boolean): void;
    jsonp(body: any, callbackName?: string, generateEtag?: boolean): void;
    stream(body: ResponseStream, errorCallback?: ((error: NodeJS.ErrnoException) => any)): void;
    download(filePath: string, generateEtag?: boolean, errorCallback?: ((error: NodeJS.ErrnoException) => any)): void;
    attachment(filePath: string, name?: string, disposition?: string, generateEtag?: boolean, errorCallback?: ((error: NodeJS.ErrnoException) => any)): void;
    location(url: string): this;
    redirect(url: string, sendQueryParams?: boolean, statusCode?: number): void;
    abort(body: any, status?: number): void;
    abortIf(condition: any, body: any, status?: number): void;
    cookie(key: string, value: any, options?: Partial<CookieOptions>): this;
    plainCookie(key: string, value: any, options?: Partial<CookieOptions>): this;
    clearCookie(key: string, options?: Partial<CookieOptions>): this;
    finish(): void;
}
